askForInput = { title, titleIncorrect, validator, Object... parameters ->
    print "${title} "
    def reader = new InputStreamReader(System.in)
    def value = reader.readLine()
    def result = validator(value, parameters)

    if (!result) {
        println titleIncorrect
        return null
    }

    return value
}

checkEmptyValidator = { value, parameters ->
    return !(null == value || "".equals(value.trim()))
}

println "Set up your MYSQL!!! Here are the commands you must execute as root"
System.in.read();

println """
create database test;

use test;

CREATE USER 'test'@'localhost' IDENTIFIED BY 'test';
GRANT ALL PRIVILEGES ON test.* TO 'test'@'localhost' WITH GRANT OPTION;

CREATE TABLE `user_login` (
  `USERNAME` varchar(200) NOT NULL,
  `PASSWORD` varchar(80) NOT NULL,
  `VERSION` bigint(20) DEFAULT NULL,
  PRIMARY KEY (`USERNAME`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `user_role` (
  `ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `ROLE` varchar(255) NOT NULL,
  `VERSION` bigint(20) DEFAULT NULL,
  `USERNAME` varchar(200) NOT NULL,
  PRIMARY KEY (`ID`),
  UNIQUE KEY `UK_p0fb0yt09yk3w4go53v203s1f` (`USERNAME`,`ROLE`),
  CONSTRAINT `FK_sd72f2nhi93p7cysmjkcom20x` FOREIGN KEY (`USERNAME`) REFERENCES `user_login` (`USERNAME`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;

INSERT INTO user_login (USERNAME, PASSWORD, VERSION) values('test', 'test', 1);
INSERT INTO user_role (USERNAME, ROLE, VERSION) values('test', 'user', 1);

"""

System.in.read()

String wildfly = askForInput("Enter the path of wildfly installation: ", "Path Incorreto", checkEmptyValidator)

def moduleLocation = new File(wildfly, "modules/system/layers/base/com/mysql/main")
moduleLocation.mkdirs()

localDir = new File(System.getProperty("user.dir"))

def ant = new AntBuilder()

ant.copy(
        file: new File(localDir, "mysql/module.xml"),
        tofile: new File(moduleLocation, "module.xml"),
        verbose: "true")

ant.copy(
        file: new File(localDir, "mysql/mysql-connector-java-5.1.34-bin.jar"),
        tofile: new File(moduleLocation, "mysql-connector-java-5.1.34-bin.jar"),
        verbose: "true")

println "Execute the follow commands: "

println "${wildfly}/bin/jboss-cli.sh --connect --file=${localDir}/cli/mysql.cli"

System.in.read()

println "${wildfly}/bin/jboss-cli.sh --connect --file=${localDir}/cli/database.cli"

System.in.read()

println "${wildfly}/bin/jboss-cli.sh --connect --file=${localDir}/cli/security.cli"

System.in.read()

def config = new File(wildfly, "standalone/configuration")

ant.copy(
        file: new File(localDir, "test.properties"),
        tofile: new File(config, "test.properties"),
        verbose: "true")

println "Now you must configure the default-security-domain manually in standalone.xml file ... heres how to do it:"

println "<default-security-domain value=\"test\"/>"
println "<default-missing-method-permissions-deny-access value=\"false\"/>"

System.in.read()

println "Done!"

