package org.jboss.issues.reproducers.rest;

import org.jboss.issues.reproducers.AuthBusiness;

import javax.annotation.Resource;
import javax.ejb.EJBContext;
import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import javax.inject.Inject;
import javax.json.Json;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.validation.constraints.NotNull;
import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.Response;

import static javax.ws.rs.core.MediaType.APPLICATION_JSON;

/**
 * Created with IntelliJ IDEA.
 * User: casmeiron
 * Date: 08/01/15
 * Time: 15:10
 */
@Path("/")
@Produces({APPLICATION_JSON})
@Consumes({APPLICATION_JSON})
@Stateless
@LocalBean
public class RootEndpoint {

    @Resource
    EJBContext ctx;

    @Inject
    AuthBusiness authBusiness;

    @GET
    @Path("auth")
    public Response auth( @NotNull @Context HttpServletRequest request ) {
        return Response.ok(
                Json
                        .createObjectBuilder()
                        .add("httpRequestPrincipal", request.getUserPrincipal().getName())
                        .add("ejbCallerPrincipal", ctx.getCallerPrincipal().getName())
                        .build()
        ).build();
    }

    @Path("login")
    @GET
    public Response login( @NotNull @Context HttpServletRequest request, @NotNull @Context HttpServletResponse response) {
         try { request.logout(); } catch(Exception ignored) { }

        try {
            authBusiness.login(request);
        } catch (Exception e) {
            e.printStackTrace();
            return Response.status(Response.Status.FORBIDDEN).build();
        }

       return auth(request);
    }
}
